#import "ProgressViewController.h"

ProgressViewController *progressViewController=nil;

@implementation ProgressViewController

+(ProgressViewController *)progress
{
    return [self progressWithMessage:@"Operation in progress, please wait..." progress:false phase:@""];
}

+(ProgressViewController *)progressWithMessage:(NSString *)message
{
    return [self progressWithMessage:message progress:false phase:@""];
}

+(ProgressViewController *)progressWithMessage:(NSString *)message progress:(BOOL)progress phase:(NSString *)phase
{
    progressViewController=[[ProgressViewController alloc] initWithNibName:@"ProgressViewController" bundle:nil];
    progressViewController.label=message;
    progressViewController.showProgress=progress;
    progressViewController.phase=phase;
    return  progressViewController;
}

+(void)dismiss
{
    [progressViewController dismissViewControllerAnimated:false completion:nil];
}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    infoText.text=self.label;
    phaseLabel.text=self.phase;
    progressProgress.hidden=self.showProgress?false:true;
	[activityIndicator startAnimating];
}
- (void)viewWillDisappear: (BOOL)animated
{
    [super viewWillDisappear:animated];
	[activityIndicator stopAnimating];
}

- (void)updateMessage:(NSString *)message
{
    infoText.text=message;
    if([[NSThread currentThread] isMainThread])
    {
        //force the screen to update
        [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:0.1]];
    }
}

- (void)updateProgress:(int)progress phase:(NSString *)phase
{
    [phaseLabel setText:phase];
    [progressProgress setProgress:(float)progress/100];
    
    [phaseLabel setHidden:FALSE];
    [progressProgress setHidden:FALSE];
}

@end
